<template>
  <page>
    <a-collapse
      v-if="services.length > 0 && !fetching"
      v-model="activeKey"
    >
      <a-collapse-panel
        v-for="(item, i) in services"
        :key="`${i}`"
        :header="`Serviço ${i + 1}`"
      >
        <a-timeline>
          <a-timeline-item>
            <strong>Descrição: </strong>{{ item.text }}
          </a-timeline-item>
          <a-timeline-item>
            <strong>Foto:</strong>
            <div>
              <img
                :src="item.logo"
                :alt="`Foto do ${item.photo}`"
              >
            </div>
          </a-timeline-item>
          <a-timeline-item>
            <strong>Ações: </strong>
            <div class="actions">
              <!-- <a-button
                type="primary"
                icon="edit"
              >
                Editar
              </a-button> -->

              <a-popconfirm
                title="Tem certeza que deseja deletar?"
                ok-text="Sim. Quero deletar."
                cancel-text="Não"
                @confirm="deleteService(item._id)"
              >
                <a-button
                  type="danger"
                  icon="delete"
                  :disabled="deleting"
                >
                  <span v-if="deleting">
                    <a-icon type="loading" />
                  </span>
                  <span v-else>Deletar</span>
                </a-button>
              </a-popconfirm>
            </div>
          </a-timeline-item>
        </a-timeline>
      </a-collapse-panel>
    </a-collapse>

    <no-data v-if="services.length === 0 && !fetching">
      Nenhum serviço foi adicionado no sistema
    </no-data>

    <page-loading v-if="fetching" />
  </page>
</template>

<script>
export default {
  name: 'Services',
  data() {
    return {
      activeKey: ['1'],
      services: [],
      deleting: false,
      fetching: false,
    };
  },
  async created() {
    try {
      this.fetching = true;
      const fetch = await this.$http.get('/subheaders');
      this.services = fetch.data;
      this.fetching = false;
    } catch (error) {
      this.fetching = false;
      this.$message.error('Ocorreu um erro ao tentar buscar os serviços. Tente novamente mais tarde.');
    }
  },
  methods: {
    async deleteService(id) {
      try {
        this.deleting = true;
        await this.$http.delete(`/subheaders/${id}`);
        this.updateServicesById(id);
        this.$message.success('Serviço deletado com sucesso');
        this.deleting = false;
      } catch (error) {
        this.deleting = false;
        this.$message.error('Ocorreu um erro ao deletar o serviço. Tente novamente mais tarde.');
      }
    },
    updateServicesById(id) {
      // eslint-disable-next-line no-underscore-dangle
      this.services = this.services.filter(service => service._id !== id);
    },
  },
};
</script>

<style lang="stylus" scoped>
.ant-timeline-item-last
  padding 0

.actions
  margin-top 1rem

  .ant-btn-primary
    margin-right 2rem
</style>
